/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package serveurClient;

import exception.RequeteException;
import data.Periode;
import data.Location;
import data.PairLocationBoolean;
import exception.LocationException;
import java.io.File;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.concurrent.CompletionService;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorCompletionService;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import serveurlocation.FinClientException;
import serveurlocation.FinServeurException;
import serveurlocation.TesterReservationCallable;
import serveurlocation.TesterReservationCallableAvecCompletion;

/**
 *
 * @author cf
 */
public class RequeteGestionClient {
    public String manage(String[] commande) 
            throws IOException, RequeteException, FinServeurException, 
                    FinClientException, LocationException {
        switch (commande[0]) {
            case "XMLWrite":  // question 16
                Location.findLocationByLieu(commande[1])
                        .XMLwrite(new File(commande[2]));
                return "XML File" + commande[2] + " généré\n";
            case "XMLRead":  // question 16
                Location.XMLread(new File(commande[1]));
                return "XML File" + commande[1] + " lu\n";
            case "RechercheTarif":  // question 5
                return Location.findLocationByLieu(commande[1]).toString() + "\n";
            case "MoyenneTarif": // question 6
                if (commande.length == 1) { // moyenne générale
                    if (Location.moyenneTarifLocation().isPresent()) {
                        return Location.moyenneTarifLocation().getAsDouble() + "\n";
                    } else throw new RequeteException(Arrays.toString(commande) 
                            + " : Pas de location presente");
                } else {
                    try { // moyenne par genre
                        Location.Genre genre = Location.Genre.valueOf(commande[1]);
                        if (Location.moyenneTarifLocation(genre).isPresent()) {
                            return Location.moyenneTarifLocation(genre).getAsDouble() 
                                    + "\n";
                        } else throw new RequeteException(Arrays.toString(commande) 
                                + " : Pas de location de ce type");
                    } catch (IllegalArgumentException e) { // moyenne par lieu
                        if (Location.moyenneTarifLocation(commande[1]).isPresent()) {
                            return Location.moyenneTarifLocation(commande[1])
                                    .getAsDouble() + "\n";
                        } else throw new RequeteException(Arrays.toString(commande) 
                                + " : Pas de location pour ce lieu");
                    }
                }
            case "NombreLieuxParTarif":  // question 7
                if (Location.nombreLieuxParTarif(Integer.parseInt(commande[1]),
                        Integer.parseInt(commande[2])).isPresent()) {
                    return Location.nombreLieuxParTarif(Integer.parseInt(commande[1]),
                            Integer.parseInt(commande[2])).getAsDouble() + "\n";
                } else throw new RequeteException(Arrays.toString(commande) 
                        + " : Pas de location pour cette fourchette de tarifs");    
            case "AjouterLocation":  // question 10
                try {
                    String lieu = commande[1];
                    Integer tarif = new Integer(commande[2]);
                    Location.Genre genre = Location.Genre.valueOf(commande[3]);
                    Location.ajouterLocation(new Location(lieu,tarif,genre));
                    return "Location ajoutée\n";
                } catch (Exception e) {
                    System.out.println(e);
                    throw new RequeteException(Arrays.toString(commande) 
                            + " : arguments non valides");}
            case "SupprimerLocation":  // question 10
                try {
                    String lieu = commande[1];
                    Location.supprimerLocationByLieu(lieu);
                    return "Location supprimée\n";
                } catch (Exception e) {
                    System.out.println(e);
                    throw new RequeteException(Arrays.toString(commande) 
                            + " : argument de lieu manquant");}
            case "ModifierLocation":  // question 10
                try {
                    String lieu = commande[1];
                    Integer tarif = new Integer(commande[2]);
                    Location.Genre genre = Location.Genre.valueOf(commande[3]);
                    Location.modifierLocation(lieu,tarif,genre);
                    return "Location modifiée\n";
                } catch (Exception e) {
                    System.out.println(e);
                    throw new RequeteException(Arrays.toString(commande) 
                            + " : arguments non valides");}
            case "ListerRéservation":  // question 10
                try {
                    String lieu = commande[1];
                    Location loc = Location.findLocationByLieu(lieu);
                    return loc.getReservations() + "\n";
                } catch (Exception e) {
                    System.out.println(e);
                    throw new RequeteException(Arrays.toString(commande) 
                            + " : réservation impossible");}
            case "TesterRéservation":  // question 12-13
                try {
                    String lieu = commande[1];
                    Location loc = Location.findLocationByLieu(lieu);
                    Date dateArrivee = new SimpleDateFormat("dd-MM-yyyy")
                            .parse(commande[2]);
                    Date dateDepart = new SimpleDateFormat("dd-MM-yyyy")
                            .parse(commande[3]);
                    Periode periode = new Periode(dateArrivee,dateDepart);
                    ExecutorService executor = Executors.newSingleThreadExecutor();
                    Future<Boolean> future = executor.submit(
                            new TesterReservationCallable(loc,periode));
                    // test de récup toutes les 10 secondes
                    while (!future.isDone()) {
                        try {
                            synchronized (this) {
                            System.out.println("J'attends !");
                            this.wait(1000);
                            }
                        } catch (InterruptedException ex) {
                            System.out.println(ex);
                        }
                    }
                   // récup directe
                    try {
                        if (future.get().booleanValue()) 
                            return "Location " + lieu + "Periode : " 
                                    + periode + "==> réservation effectuée\n";
                        else 
                            return "Location " + lieu + "Periode : " 
                                    + periode + "==> réservation non effectuée\n";
                    } catch (InterruptedException | ExecutionException e) {
                        System.out.println(e);
                        throw new RequeteException(Arrays.toString(commande) 
                                + " : test réservation impossible");
                    }
                } catch (LocationException | ParseException | RequeteException e) {
                    System.out.println(e);
                    throw new RequeteException(Arrays.toString(commande) 
                            + " : test réservation impossible");
                }
            case "TesterRéservationAvecCompletion":  // question 14
                try {
                    ExecutorService executor = Executors.newSingleThreadExecutor();
                    CompletionService<PairLocationBoolean> completionService 
                            = new ExecutorCompletionService<>(executor);
                    List<Future<PairLocationBoolean>> futureList 
                            = new ArrayList<>();
                    String s = "";
                    for(int i=1;i<=10;i++) {
                        String lieu = commande[i];
                        Location loc;
                        try {
                            loc = Location.findLocationByLieu(lieu);
                            futureList.add(
                                    completionService.submit(
                                        new TesterReservationCallableAvecCompletion(loc)
                                    )
                            );            
                        } catch (LocationException e) {
                            s = s + "Location non définie pour le lieu " 
                                    + lieu + "; ";
                        }
                    }
                    List<Future<PairLocationBoolean>> futureList2 
                            = new ArrayList<>();
                    while ( !futureList.isEmpty() ) {
                        try {
                            for (Future<PairLocationBoolean> future : futureList) {
                                if (future.isDone()) {
                                    s = s + "[CompletionService] " 
                                            + future.get().getB() 
                                            + ":" 
                                            + future.get().getLoc()
                                            + "; ";
                                }
                                else futureList2.add(future);
                            }
                            futureList = futureList2;
                            futureList2.clear();
                        } catch (InterruptedException ex) {
                            System.out.println(ex);
                        }
                    }
                    return s + "\n";
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RequeteException(Arrays.toString(commande) 
                            + " : test réservation completion impossible");
                }
            case "AjouterRéservation":  // question 10
                try {
                    String lieu = commande[1];
                    Location loc = Location.findLocationByLieu(lieu);
                    Date dateArrivee = new SimpleDateFormat("dd-MM-yyyy")
                            .parse(commande[2]);
                    Date dateDepart = new SimpleDateFormat("dd-MM-yyyy")
                            .parse(commande[3]);
                    Periode periode = new Periode(dateArrivee,dateDepart);
                    Location.ajouterReservation(loc,periode);
                    return "Réservation ajoutée\n";
                } catch (LocationException | ParseException e) {
                    System.out.println(e);
                    throw new RequeteException(Arrays.toString(commande) 
                            + " : réservation impossible");}
            case "SupprimerRéservation":  // question 10
                try {
                    String lieu = commande[1];
                    Location loc = Location.findLocationByLieu(lieu);
                    Date dateArrivee = new SimpleDateFormat("dd-MM-yyyy")
                            .parse(commande[2]);
                    Date dateDepart = new SimpleDateFormat("dd-MM-yyyy")
                            .parse(commande[3]);
                    Periode periode = new Periode(dateArrivee,dateDepart);
                    Location.supprimerReservation(loc,periode);
                    return "Réservation supprimée\n";
                } catch (LocationException | ParseException e) {
                    System.out.println(e);
                    throw new RequeteException(Arrays.toString(commande) 
                            + " : réservation impossible");}
            case "ModifierRéservation":  // question 10
                try {
                    String lieu = commande[1];
                    Location loc = Location.findLocationByLieu(lieu);
                    Date dateArrivee1 = new SimpleDateFormat("dd-MM-yyyy")
                            .parse(commande[2]);
                    Date dateDepart1 = new SimpleDateFormat("dd-MM-yyyy")
                            .parse(commande[3]);
                    Periode periode1 = new Periode(dateArrivee1,dateDepart1);
                    Date dateArrivee2 = new SimpleDateFormat("dd-MM-yyyy")
                            .parse(commande[4]);
                    Date dateDepart2 = new SimpleDateFormat("dd-MM-yyyy")
                            .parse(commande[5]);
                    Periode periode2 = new Periode(dateArrivee2,dateDepart2);
                    Location.modifierReservation(loc,periode1,periode2);
                    return "Réservation modifiée\n";
                } catch (LocationException | ParseException e) {
                    System.out.println(e);
                    throw new RequeteException(Arrays.toString(commande) 
                            + " : réservation impossible");}
            case "FinServeur": throw new FinServeurException();
            case "FinClient": throw new FinClientException();
            default: throw new RequeteException(Arrays.toString(commande) 
                    + " : Requete inconnue");
        }
    }
}
